<script setup lang="ts">
  import debounce from 'lodash/debounce';
  import { useVuelidate } from '@vuelidate/core';
  import type { CustomListingType } from '@shopware-pwa/composables-next';
  import { ShopwareSearchParams } from '@shopware-pwa/types';
  import { ProductListingKey } from '~/helpers/injection';

  const props = defineProps<{
    value?: ShopwareSearchParams;
    listingType: CustomListingType;
  }>();

  provide(ProductListingKey, {
    listingType: props.listingType,
  });

  const DEBOUNCE_SEARCH_TIME = 750; // ms

  const emits = defineEmits<{
    (e: 'change', value: ShopwareSearchParams): void;
  }>();
  const listingTagsEl = ref();

  const filterCount = computed(() => {
    if (!listingTagsEl.value?.tags?.length) return 0;
    const filterTags = listingTagsEl.value?.tags.filter(
      (x: { key: string; label: string; data?: any; text?: string }) => {
        return x.key !== 'term';
      },
    );
    return filterTags.length;
  });

  const { getAvailableFilters, getSortingOrders } = useListing({
    listingType: props.listingType,
  });

  const DEFAULT_VALUE = {
    manufacturer: undefined,
    properties: undefined,
    'min-price': undefined,
    'max-price': undefined,
    'shipping-free': undefined,
    order: getSortingOrders.value[0].key,
    rating: undefined,
    term: undefined,
  };

  const currentCondition = reactive<ShopwareSearchParams>({ ...DEFAULT_VALUE });

  const $v = useVuelidate({}, currentCondition);

  onMounted(() => {
    if (props.value && Object.keys(props.value || {})?.length) {
      Object.keys(props.value).forEach((key: string) => {
        if (key !== 'query') {
          (currentCondition as any)[key] = (props.value as any)?.[key];
        } else {
          currentCondition.term = (props.value as any).query?.[0]?.query?.value;
        }
      });
      $v.value.$touch();
    }
  });

  const onCurrentFiltersChanged = async (filter: {
    [k: string]: string | boolean | number | number[];
  }) => {
    const keys = Object.keys(filter);
    keys.forEach((key: string) => {
      if (typeof key !== 'string') return;
      (currentCondition as any)[key] = filter[key];
    });
    await $v.value.$validate();
    changeDebounced();
  };

  const onCurrentSortingOrderChanged = async (order: string) => {
    currentCondition.order = order;
    await $v.value.$validate();
    changeDebounced();
  };

  const onSearchTermChanged = async (input?: string) => {
    currentCondition.term = input || '';
    await $v.value.$validate();
    changeDebounced();
  };

  const changeDebounced = debounce(() => {
    const temp: any = { ...currentCondition };
    // clear all undefined fields
    Object.keys(temp).forEach((key: string) => (temp[key] === undefined ? delete temp[key] : {}));
    if (temp.term) {
      // search by name & productNumber
      temp.query = [
        {
          score: 500,
          query: { type: 'contains', field: 'name', value: temp.term },
        },
        {
          score: 500,
          query: { type: 'contains', field: 'productNumber', value: temp.term },
        },
      ];
      delete temp.term;
    }
    emits('change', temp);
  }, DEBOUNCE_SEARCH_TIME);

  const handleReset = () => {
    Object.assign(currentCondition, { ...DEFAULT_VALUE });
    emits('change', currentCondition);
    $v.value.$reset();
  };

  // const hasTags = computed(() => Object.values(selectedTags).some(Boolean));
</script>

<template>
  <div class="bg-background-raised flex flex-col gap-6 p-6">
    <SwSearchInput class="py-2" :value="currentCondition.term" @change="onSearchTermChanged" />

    <div v-if="getSortingOrders.length">
      <p class="mb-2 text-sm font-bold">
        {{ $t('sort.sorting') }}
      </p>

      <ListingSortings
        :model-value="currentCondition.order"
        @update:model-value="onCurrentSortingOrderChanged"
      />
    </div>

    <div v-if="getAvailableFilters.length">
      <p class="mb-2 text-sm font-bold">
        {{ $t('filters') + ` (${filterCount})` }}
      </p>
      <ListingFilters
        :model-value="currentCondition"
        @update:model-value="onCurrentFiltersChanged"
      />
    </div>

    <div class="border-(border t) pt-8">
      <ListingTags
        ref="listingTagsEl"
        :model-value="currentCondition"
        @update:model-value="onCurrentFiltersChanged"
      />
    </div>

    <SwButton v-if="$v.$dirty" variant="danger" class="w-fit py-2.5" @click="handleReset">
      {{ $t('resetFilters') }}
    </SwButton>
  </div>
</template>
